package at.jku.students.binarytree;

import java.util.Arrays;

import at.jku.ssw.set.impl.BinaryTreeSet;
import at.jku.ssw.util.Out;

public class BinaryTreeMain {

	public static void main(String[] args) {
		BinaryTreeSet tree = new BinaryTreeSet();

		tree.add(4);
		tree.add(1);
		tree.add(0);
		tree.add(3);
		tree.add(5);
		tree.add(6);
		tree.add(7);
		tree.add(8);

		System.out.println("Height:" + tree.height());
		System.out.println("Width:" + tree.width());

		makeDot(tree, "tree1.dot");
		printInOrder(tree);
		printPreOrder(tree);
		printPostOrder(tree);

		int[] inorder = BinaryTreeUtil.inorder(tree);
		int[] preorder = BinaryTreeUtil.preorder(tree);

		BinaryTreeSet newTree = BinaryTreeUtil.buildTree(inorder, preorder);
		makeDot(newTree, "newTree1.dot");
		printInOrder(newTree);
		printPreOrder(newTree);
		printPostOrder(newTree);

		System.out.println(tree.treeString());

	}

	private static void printInOrder(BinaryTreeSet tree) {
		System.out.print("  inorder: ");
		System.out.println(Arrays.toString(BinaryTreeUtil.inorder(tree)));
	}

	private static void printPreOrder(BinaryTreeSet tree) {
		System.out.print(" preorder: ");
		System.out.println(Arrays.toString(BinaryTreeUtil.preorder(tree)));
	}

	private static void printPostOrder(BinaryTreeSet tree) {
		System.out.print("postorder: ");
		System.out.println(Arrays.toString(BinaryTreeUtil.postorder(tree)));
	}

	static void makeDot(BinaryTreeSet tree, String filename) {
		Out.open(filename);
		Out.print(tree.makeDot());
		Out.close();
	}
}
